/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2005  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef JSFILTERCONTEXT_H_
#define JSFILTERCONTEXT_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "NonCopyable.h"
#include <string>
#include <memory>
#include <vector>

class BString;
class FilterTag;
class FilterGroupTag;

class JsFilterContext
{
	DECLARE_NON_COPYABLE(JsFilterContext)
public:
	JsFilterContext();
	
	~JsFilterContext();
	
	std::auto_ptr<std::string> performAction(
		FilterTag const& filter_tag, FilterGroupTag const& group_tag,
		std::string const& js_code, std::vector<BString> const& params);
private:
	enum { STACK_SIZE = 5*1024 };
	
	class Impl;
	class JsException;
	
	std::auto_ptr<Impl> m_ptrImpl;
};

#endif
