/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2006  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef DNSCACHE_H_
#define DNSCACHE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>

class InetAddr;
class SymbolicInetAddr;

class DnsCache
{
private:
	DnsCache() {}
	
	virtual ~DnsCache() {}
public:
	static DnsCache* instance();
	
	virtual void put(
		SymbolicInetAddr const& symbolic_addr,
		std::vector<InetAddr> const& resolved_addrs) = 0;
	
	virtual std::vector<InetAddr> get(
		SymbolicInetAddr const& symbolic_addr) = 0;
private:
	enum { CAPACITY = 256 };
	enum { TIMEOUT = 120 }; // seconds
	
	struct Entry;
	class Impl;
	friend class DnsCache::Impl;
};

#endif
