/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2004  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTTPSTATESTATUSLINE_H_
#define HTTPSTATESTATUSLINE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "HttpState.h"
#include "RequestPtr.h"

class HttpResponseParser;
class BString;

class HttpStateStatusLine : public HttpState
{
public:
	HttpStateStatusLine(HttpResponseParser& parser);
	
	virtual ~HttpStateStatusLine();
	
	void activate(ConstRequestPtr const& req);
	
	virtual HttpState* processNewData(
		SplittableBuffer& input, bool eof,
		SplittableBuffer& body_data, bool& body_eof);
	
	virtual void cleanup();
private:
	HttpState* processStatusLine(BString const& line);
	
	HttpState* switchToSimpleResponse();
	
	HttpResponseParser& m_rParser;
	ConstRequestPtr m_ptrRequest;
};

#endif
