/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2007  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTTPCACHE_MEMORYREADER_H_
#define HTTPCACHE_MEMORYREADER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "AbstractResponseReader.h"
#include "NonCopyable.h"
#include "BString.h"
#include <ace/Basic_Types.h> // for ssize_t
#include <memory>

class HttpResponseMetadata;

namespace HttpCache
{

class MemoryReader : public AbstractResponseReader
{
	DECLARE_NON_COPYABLE(MemoryReader)
public:
	MemoryReader(std::auto_ptr<HttpResponseMetadata> metadata,
		BString const& body);
	
	virtual ~MemoryReader();
	
	virtual std::auto_ptr<HttpResponseMetadata> retrieveMetadata();
	
	virtual ssize_t readBodyData(void* buf, size_t len);
private:
	std::auto_ptr<HttpResponseMetadata> m_ptrMetadata;
	BString m_bodyData;
};

} // namespace HttpCache

#endif
