/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2006  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef PORTSET_H_
#define PORTSET_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <vector>
#include <string>
#include <iosfwd>

class PortSet
{
public:
	bool contains(unsigned port) const;
	
	void toStream(std::ostream& strm) const;
	
	bool fromString(std::string const& str);
	
	void swap(PortSet& other);
private:
	class Parser;
	
	struct Range
	{
		unsigned from;
		unsigned to;
		
		Range(unsigned from, unsigned to) : from(from), to(to) {}
		
		bool isInRange(unsigned port) const;
		
		void toStream(std::ostream& strm) const;
	};
	
	std::vector<Range> m_portRanges;
};


inline void swap(PortSet& o1, PortSet& o2)
{
	o1.swap(o2);
}

#endif
