/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2007  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "pch.h"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "ColorRectangle.h"
#include <gdkmm/window.h>

namespace GtkGUI
{

ColorRectangle::ColorRectangle()
{
}

ColorRectangle::ColorRectangle(Gdk::Color const& color)
:	m_color(color)
{
}

void
ColorRectangle::setColor(Gdk::Color const& color)
{
	m_color = color;
	if (m_ptrGC) {
		m_ptrGC->set_rgb_fg_color(m_color);
	}
}

bool
ColorRectangle::on_expose_event(GdkEventExpose* evt)
{
	Glib::RefPtr<Gdk::Window> wnd = get_window();
	if (!m_ptrGC) {
		m_ptrGC = Gdk::GC::create(wnd);
		m_ptrGC->set_rgb_fg_color(m_color);
	}
	wnd->draw_rectangle(
		m_ptrGC, true,
		evt->area.x, evt->area.y,
		evt->area.width, evt->area.height
	);
	return true;
}

} // namespace GtkGUI
