/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2007  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CONFIGERRORHANDLER_H_
#define CONFIGERRORHANDLER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "ConfErrorHandler.h"
#include <glibmm/ustring.h>

class ConfError;

namespace GtkGUI
{

class ConfigErrorHandler : public ConfErrorHandler
{
public:
	ConfigErrorHandler(Glib::ustring const& fname);
	
	int numErrors() const { return m_numErrors; }
	
	int numWarnings() const { return m_numWarnings; }
private:
	enum { MAX_ENTRIES = 5 };
	
	virtual bool handleError(ConfError const& err);
	
	void writeToLog(ConfError const& err);
	
	void reportMoreErrors();

	Glib::ustring m_fileName;
	int m_numErrors;
	int m_numWarnings;
};

} // namespace GtkGUI

#endif
